'                      Star Data Editor
'                         Optec, Inc.
'
'======version history
'
'V1.20
'   added FOE catalog for Allsky
'
'V1.11
'   added page breaks for printing catalog
'
'V1.10
'  compiled with LB4.5
'  increased dim
'  print report
'
'V1.00
'
'======initialize star data array
DIM info$(10,10)
files "c:\",info$()         'get file infomation about C drive
DIM StarData$(400)
DIM SDitem$(400,13)
'
'=======initialize any variables
'
VersionNumber$ = "1.20"

StarDataFile$ = ""
DataLines = 0
'
'======set up main window
'
[WindowSetup]
    NOMAINWIN
    WindowWidth = 560 : WindowHeight = 377
    UpperLeftX = INT((DisplayWidth-WindowWidth)/2)
    UpperLeftY = INT((DisplayHeight-WindowHeight)/2)

[ControlSetup]
Menu        #DataEdit, "File",  "Open Variable/Comp Star Database", [Open_Star_Data],_
                                "Open Transformation Star Database", [Open_Trans_Data],_
                                "Open SOE Star Database", [Open_SOE_Data],_
                                "Open FOE Star Database", [Open_FOE_Data],_
                                "Save Data File", [Save_Data_File],_
                                "Print Catalog", [Print_Cat],_
                                "Quit", [Quit_Data_Editor]

Menu        #DataEdit, "Sort",  "Sort by Name", [Sort_Name],_
                                "Sort by RA", [Sort_RA],_
                                "Sort by Type", [Sort_Type],_
                                "Sort by J", [Sort_J],_
                                "Sort by J-H", [Sort_JH]

Menu        #DataEdit, "Help", "About", [About], "Help", [Help]

statictext  #DataEdit.statictext1,  "Name", 40, 20, 60, 14
statictext  #DataEdit.statictext2,  "RA(2000)", 195, 20, 80, 14
statictext  #DataEdit.statictext3,  "DEC(2000)", 285, 20, 90, 14
statictext  #DataEdit.statictext4,  "J", 410, 20, 10, 14
statictext  #DataEdit.statictext5,  "J-H", 470, 20, 30, 14
statictext  #DataEdit.statictext6,  "Type", 134, 20, 40, 14
statictext  #DataEdit.statictext7,  "h", 178, 239, 10, 14
statictext  #DataEdit.statictext8,  "m", 210, 239, 10, 14
statictext  #DataEdit.statictext9,  "s", 242, 239, 10, 14
statictext  #DataEdit.statictext10, "d", 285, 239, 10, 14
statictext  #DataEdit.statictext11, "m", 318, 239, 10, 14
statictext  #DataEdit.statictext12, "s", 350, 239, 10, 14

button      #DataEdit.select, "Select Star",[List_Data],UL, 15, 290, 120, 25
button      #DataEdit.new, "New Star",[New_Star.click],UL, 150, 290, 120, 25
button      #DataEdit.delete, "Delete Star",[Delete_Star.click],UL, 285, 290, 120, 25
button      #DataEdit.save, "Save Changes",[Save_Star.click],UL, 420, 290, 120, 25

textbox     #DataEdit.name, 15, 255, 120, 25
textbox     #DataEdit.type, 140, 255, 21, 25
textbox     #DataEdit.rah, 168, 255, 32, 25
textbox     #DataEdit.ram, 200, 255, 32, 25
textbox     #DataEdit.ras, 232, 255, 32, 25
textbox     #DataEdit.decd, 272, 255, 36, 25
textbox     #DataEdit.decm, 308, 255, 32, 25
textbox     #DataEdit.decs, 340, 255, 32, 25
textbox     #DataEdit.j, 380, 255, 70, 25
textbox     #DataEdit.jh, 458, 255, 60, 25

listbox     #DataEdit.StarData, StarData$(),[List_Data], 15, 40, 520, 195

Open "Star Data Editor   JH Photometry" for Window as #DataEdit
    #DataEdit "trapclose [Quit_Data_Editor]"
    #DataEdit "font courier_new 10 14"

[loop]
    StarDataFile$ = ""
Wait

[Quit_Data_Editor]
    if StarDataFile$ <> "" then
        confirm "Have you saved the data file?"+chr$(13)+_
                "Press YES to exit program"; Answer$
        if Answer$ = "no" then
            Wait
        end if
    end if
    close #DataEdit
END

[Open_Star_Data]
    redim StarData$(4000)
    redim SDitem$(4000,13)
    StarDataFile$ = "Star Database JH.txt"
    gosub [Open_Data_File]
    print #DataEdit.StarData, "reload"
Wait

[Open_Trans_Data]
    redim StarData$(4000)
    redim SDitem$(4000,13)
    StarDataFile$ = "Transformation Database JH.txt"
    gosub [Open_Data_File]
    print #DataEdit.StarData, "reload"
Wait

[Open_SOE_Data]
    redim StarData$(4000)
    redim SDitem$(4000,13)
    StarDataFile$ = "SOE Database JH.txt"
    gosub [Open_Data_File]
    print #DataEdit.StarData, "reload"
Wait

[Open_FOE_Data]
    redim StarData$(4000)
    redim SDitem$(4000,13)
    StarDataFile$ = "FOE Database JH.txt"
    gosub [Open_Data_File]
    print #DataEdit.StarData, "reload"
Wait

[Save_Data_File]
    if StarDataFile$ = "" then
        notice "no opened file to save"
    else
        gosub [Save_File]
        if StarDataFile$ = "Star Database JH.txt" then
            notice "Star Database JH.txt saved"+chr$(13)+"backup saved as Star Database JH.old"
        end if
        if StarDataFile$ = "Transformation Database JH.txt" then
            notice "Transformation Database JH.txt saved"+chr$(13)+"backup saved as Transformation Database JH.old"
        end if
        if StarDataFile$ = "SOE Database JH.txt" then
            notice "SOE Database JH.txt saved"+chr$(13)+"backup saved as SOE Database JH.old"
        end if
        if StarDataFile$ = "FOE Database JH.txt" then
            notice "FOE Database JH.txt saved"+chr$(13)+"backup saved as SOE Database JH.old"
        end if
    end if
Wait
'
[Print_Cat]
    If StarDataFile$ = "" then
        notice "Open Database"
    else
        printerdialog
        if PrinterName$ <> "" then

            if  DataLines <> 0 then
                DataLines$ = str$(DataLines)
            else
                DataLines$ = "50"
            end if
            Prompt "Enter number of data lines per page";DataLines$
            DataLines = val(DataLines$)

            Pages = INT(DataIndexMax/DataLines )
            PagesRemainder = DataIndexMax MOD DataLines
            if PagesRemainder = 0 then
                Pages = Pages - 1
            end if

            for J = 0 to Pages
                lprint StarDataFile$
                lprint " "
                lprint "Name           Type  RA(2000)    DEC(2000)     J       J-H"
                lprint " "
                for DataIndex = (1 + J * DataLines) to (DataLines + J * DataLines)
                    lprint    left$(SDitem$(DataIndex,1)+"            ",12);"   ";_
                              right$("   "+SDitem$(DataIndex,2),1);"     ";_
                              right$("   "+SDitem$(DataIndex,3),2);"h";_
                              right$("   "+SDitem$(DataIndex,4),2);"m";_
                              right$("   "+SDitem$(DataIndex,5),2);"s  ";_
                              right$("   "+SDitem$(DataIndex,6),3);"d";_
                              right$("   "+SDitem$(DataIndex,7),2);"m";_
                              right$("   "+SDitem$(DataIndex,8),2);"s   ";_
                              right$("   "+SDitem$(DataIndex,9),6);"   ";_
                              right$("   "+SDitem$(DataIndex,10),5)
                     if DataIndex = DataIndexMax then
                        EXIT FOR
                     end if
                next

                lprint " "
                lprint " "
                lprint "                                        page ";str$(J + 1);" of ";str$(Pages + 1)
                Dump
            next
        end if
    end if
Wait
'
[About]
    notice "Star Database Editor   JH Photometry"+chr$(13)+_
           "Version "+VersionNumber$+chr$(13)+_
           "copyright 2014-2015, Gerald Persha"+chr$(13)+_
           "www.SSPDataq.com"
Wait

[Help]
    run "hh photometry JH.chm"
Wait

[Save_Star.click]

    print #DataEdit.name, "!contents? Temporary$";
    if Temporary$ = "" then
        notice "nothing to save"
        wait
    end if

    Temporary$ = upper$(Temporary$)
    FoundItem$ = "N"
    for DataIndex = 1 to DataIndexMax
        if Temporary$ = SDitem$(DataIndex,1) then
            Index = DataIndex
            FoundItem$ = "Y"
            exit for
        end if
    next

    if FoundItem$ = "Y" then
        confirm "save changes to "+Temporary$+" ?";Answer$
        if Answer$ = "yes" then
            Index = DataIndex
        else
            wait
        end if
    else
        confirm "Enter new star "+Temporary$+" ?"; Answer$
        if Answer$ = "yes" then
            Index = DataIndexMax + 1
            DataIndexMax = Index
        else
            wait
        end if
    end if

    print #DataEdit.name, "!contents?"                      'capture star name, 12 characters maximum
    input #DataEdit.name, SDitem$(Index,1)
    SDitem$(Index,1) = left$(upper$(SDitem$(Index,1)),12)

    print #DataEdit.type, "!contents?"
    input #DataEdit.type, SDitem$(Index,2)
    SDitem$(Index,2) = left$(upper$(SDitem$(Index,2)),1)
    if StarDataFile$ = "Star Database JH.txt" then
        if SDitem$(Index,2) <> "C" AND SDitem$(Index,2) <> "V" AND SDitem$(Index,2) <> "Q" then
            notice "type must be a C, V or a Q"
            wait
        end if
    end if

    print #DataEdit.rah, "!contents?"
    input #DataEdit.rah, SDitem$(Index,3)
    Temporary = val(SDitem$(Index,3))
    if Temporary > 24 OR Temporary < 0 then
        notice "RA hour is not a valid entry"
        wait
    end if
    SDitem$(Index,3) = using("##", Temporary)

    print #DataEdit.ram, "!contents?"
    input #DataEdit.ram, SDitem$(Index,4)
    Temporary = val(SDitem$(Index,4))
    if Temporary > 60 OR Temporary < 0 then
        notice "RA minute is not a valid entry"
        wait
    end if
    SDitem$(Index,4) = using("##", Temporary)

    print #DataEdit.ras, "!contents?"
    input #DataEdit.ras, SDitem$(Index,5)
    Temporary = val(SDitem$(Index,5))
    if Temporary > 60 OR Temporary < 0 then
        notice "RA second is not a valid entry"
        wait
    end if
    SDitem$(Index,5) = using("##", Temporary)

    print #DataEdit.decd, "!contents?"
    input #DataEdit.decd, SDitem$(Index,6)
    Temporary = abs(val(SDitem$(Index,6)))
    if Temporary >= 90  then
        notice "DEC degree is not a valid entry"
        wait
    end if
    if mid$(SDitem$(Index,6),1,1) = "-" OR_
        mid$(SDitem$(Index,6),2,1) = "-" OR_
        mid$(SDitem$(Index,6),3,1) = "-" then
        SDitem$(Index,6) = "-"+using("##",Temporary)
    else
        SDitem$(Index,6) = using("###", Temporary)
    end if

    print #DataEdit.decm, "!contents?"
    input #DataEdit.decm, SDitem$(Index,7)
    Temporary = val(SDitem$(Index,7))
    if Temporary > 60 OR Temporary < 0 then
        notice "DEC minute is not a valid entry"
        wait
    end if
    SDitem$(Index,7) = using("##", Temporary)

    print #DataEdit.decs, "!contents?"
    input #DataEdit.decs, SDitem$(Index,8)
    Temporary = val(SDitem$(Index,8))
    if Temporary > 60 OR Temporary < 0 then
        notice "DEC second is not a valid entry"
        wait
    end if
    SDitem$(Index,8) = using("##", Temporary)

    print #DataEdit.j, "!contents?"
    input #DataEdit.j, SDitem$(Index,9)
    Temporary = val(SDitem$(Index,9))
    if Temporary > 20 OR Temporary < -5 then
        notice "J magnitude is not a valid entry"
        wait
    end if
    SDitem$(Index,9) = using("###.##", Temporary)

    print #DataEdit.jh, "!contents?"
    input #DataEdit.jh, SDitem$(Index,10)
    Temporary = val(SDitem$(Index,10))
    if Temporary > 4 OR Temporary < -4 then
        notice "J-H index is not a valid entry"
        wait
    end if
    SDitem$(Index,10) = using("##.##", Temporary)

    gosub [Create_Star_List]
    print #DataEdit.StarData, "reload"
wait

[New_Star.click]

    if (StarDataFile$ <> "Star Database JH.txt") AND_
       (StarDataFile$ <> "Transformation Database JH.txt") AND_
       (StarDataFile$ <> "SOE Database JH.txt") AND_
       (StarDataFile$ <> "FOE Database JH.txt") then
        notice "Open a data file first"
        wait
    end if

    print #DataEdit.name, ""
    print #DataEdit.type, ""
    print #DataEdit.rah,  ""
    print #DataEdit.ram,  ""
    print #DataEdit.ras,  ""
    print #DataEdit.decd, ""
    print #DataEdit.decm, ""
    print #DataEdit.decs, ""
    print #DataEdit.j,    ""
    print #DataEdit.jh,   ""

    print #DataEdit.name, "!setfocus";
wait

[Delete_Star.click]
    print #DataEdit.name, "!contents? Temporary$";
    if Temporary$ = "" then
        notice "nothing to delete"
        wait
    end if
    Temporary$ = upper$(Temporary$)
    FoundItem$ = "N"
    for DataIndex = 1 to DataIndexMax
        if Temporary$ = SDitem$(DataIndex,1) then
            Index = DataIndex
            FoundItem$ = "Y"
            exit for
        end if
    next

    If FoundItem$ = "Y" then
        confirm "Do you wish to delete "+SDitem$(Index,1)+"?";Answer$
        if Answer$ = "yes" then
            SDitem$(Index,1) = "ZZZZZZZZ"
            sort SDitem$(),1,DataIndexMax,1
            if SDitem$(DataIndexMax,1) = "ZZZZZZZZ" then
                DataIndexMax = DataIndexMax - 1
                gosub [Create_Star_List]
                StarData$(DataIndexMax + 1) = ""
                print #DataEdit.StarData, "reload"
            end if
        end if
    else
        notice "nothing to delete"
    end if

    print #DataEdit.name, ""
    print #DataEdit.type, ""
    print #DataEdit.rah,  ""
    print #DataEdit.ram,  ""
    print #DataEdit.ras,  ""
    print #DataEdit.decd, ""
    print #DataEdit.decm, ""
    print #DataEdit.decs, ""
    print #DataEdit.j,    ""
    print #DataEdit.jh,   ""
wait

[List_Data]
    print #DataEdit.StarData, "selectionindex? Index"
    print #DataEdit.name, SDitem$(Index,1)
    print #DataEdit.type, SDitem$(Index,2)
    print #DataEdit.rah, SDitem$(Index,3)
    print #DataEdit.ram, SDitem$(Index,4)
    print #DataEdit.ras, SDitem$(Index,5)
    print #DataEdit.decd, SDitem$(Index,6)
    print #DataEdit.decm, SDitem$(Index,7)
    print #DataEdit.decs, SDitem$(Index,8)
    print #DataEdit.j, SDitem$(Index,9)
    print #DataEdit.jh, SDitem$(Index,10)
wait
'
[Sort_Name]
    sort SDitem$(),1,DataIndexMax,1
    gosub [Create_Star_List]
    print #DataEdit.StarData, "reload"
wait
'
[Sort_RA]
    for DataIndex = 1 to DataIndexMax
        SDitem$(DataIndex,11) =  using("##.###",(val(SDitem$(DataIndex,3))+_
                                 val(SDitem$(DataIndex,4))/60+_
                                 val(SDitem$(DataIndex,5))/3600))
    next
    sort SDitem$(),1,DataIndexMax,11
    gosub [Create_Star_List]
    print #DataEdit.StarData, "reload"
wait
'
[Sort_Type]
    sort SDitem$(),1,DataIndexMax,2
    gosub [Create_Star_List]
    print #DataEdit.StarData, "reload"
wait
'
[Sort_J]
    for DataIndex = 1 to DataIndexMax
        SDitem$(DataIndex,12) =  using("##.###",(val(SDitem$(DataIndex,9))+5))
    next
    sort SDitem$(),1,DataIndexMax,12
    gosub [Create_Star_List]
    print #DataEdit.StarData, "reload"
wait
'
[Sort_JH]
    for DataIndex = 1 to DataIndexMax
        SDitem$(DataIndex,13) =  using("##.###",(val(SDitem$(DataIndex,10))+5))
    next
    sort SDitem$(),1,DataIndexMax,13
    gosub [Create_Star_List]
    print #DataEdit.StarData, "reload"
wait
'
'=====gosub routines
'
[Open_Data_File]
    open StarDataFile$ for input as #StarData
    DataIndex = 0
    while eof(#StarData) = 0
        DataIndex = DataIndex + 1
        input #StarData,SDitem$(DataIndex,1)        'star name

        if SDitem$(DataIndex,1) = "" then           'check to see if there are extra LF CR at end of file
            DataIndex = DataIndex - 1
            exit while
        end if

        input #StarData,SDitem$(DataIndex,2),_      'type: C or V, spectral type for SOE and Transformation
                        SDitem$(DataIndex,3),_      'RA hour
                        SDitem$(DataIndex,4),_      'RA minute
                        SDitem$(DataIndex,5),_      'RA second
                        SDitem$(DataIndex,6),_      'DEC degree
                        SDitem$(DataIndex,7),_      'DEC minute
                        SDitem$(DataIndex,8),_      'DEC second
                        SDitem$(DataIndex,9),_      'J magnitude
                        SDitem$(DataIndex,10)       'J-H index
    wend
    close #StarData
    DataIndexMax = DataIndex
                                                    'convert RA to hours.xxx and use this parameter for
                                                    'sorting by RA
    for DataIndex = 1 to DataIndexMax
        SDitem$(DataIndex,11) =  using("##.###",(val(SDitem$(DataIndex,3))+_
                                 val(SDitem$(DataIndex,4))/60+_
                                 val(SDitem$(DataIndex,5))/3600))
    next

    gosub [Create_Star_List]

return
'
[Create_Star_List]
    for DataIndex = 1 to DataIndexMax
        StarData$(DataIndex) = left$(SDitem$(DataIndex,1)+"            ",12)+"  "+_
                               right$("   "+SDitem$(DataIndex,2),1)+"   "+_
                               right$("000"+SDitem$(DataIndex,3),2)+"h"+_
                               right$("000"+SDitem$(DataIndex,4),2)+"m"+_
                               right$("000"+SDitem$(DataIndex,5),2)+"s "+_
                               right$("   "+SDitem$(DataIndex,6),3)+"d"+_
                               right$("000"+SDitem$(DataIndex,7),2)+"m"+_
                               right$("000"+SDitem$(DataIndex,8),2)+"s  "+_
                               right$("   "+SDitem$(DataIndex,9),6)+"   "+_
                               right$("   "+SDitem$(DataIndex,10),5)
    next
return
'
[Save_File]
    if StarDataFile$ = "Star Database JH.txt" then
        files DefaultDir$, "Star Database JH.old", info$()
        if val(info$(0,0)) > 0 then
            kill "Star Database JH.old"
        end if
        name "Star Database JH.txt" as "Star Database JH.old"
    end if
    if StarDataFile$ = "Transformation Database JH.txt" then
        files DefaultDir$, "Transformation Database JH.old", info$()
        if val(info$(0,0)) > 0 then
            kill "Transformation Database JH.old"
        end if
        name "Transformation Database JH.txt" as "Transformation Database JH.old"
    end if
    if StarDataFile$ = "SOE Database JH.txt" then
        files DefaultDir$, "SOE Database JH.old", info$()
        if val(info$(0,0)) > 0 then
            kill "SOE Database JH.old"
        end if
        name "SOE Database JH.txt" as "SOE Database JH.old"
    end if
    if StarDataFile$ = "FOE Database JH.txt" then
        files DefaultDir$, "FOE Database JH.old", info$()
        if val(info$(0,0)) > 0 then
            kill "FOE Database JH.old"
        end if
        name "FOE Database JH.txt" as "FOE Database JH.old"
    end if

    open StarDataFile$ for output as #StarData
    for DataIndex = 1 to DataIndexMax
        print #StarData, SDitem$(DataIndex,1);","; SDitem$(DataIndex,2);","; SDitem$(DataIndex,3);",";_
                         SDitem$(DataIndex,4);","; SDitem$(DataIndex,5);","; SDitem$(DataIndex,6);",";_
                         SDitem$(DataIndex,7);","; SDitem$(DataIndex,8);","; SDitem$(DataIndex,9);",";_
                         SDitem$(DataIndex,10)
    next
    close #StarData
return
'
'
end
